diff --git a/src/iperf3.1 b/src/iperf3.1
index 76b6f26fa..78dd20fa0 100644
--- a/src/iperf3.1
+++ b/src/iperf3.1
@@ -103,7 +103,7 @@ number of parallel client streams to run
 run in reverse mode (server sends, client receives)
 .TP
 .BR -w ", " --window " \fIn\fR[KM]"
-TCP window size / socket buffer size (this gets sent to the server and used on that side too)
+window size / socket buffer size (this gets sent to the server and used on that side too)
 .TP
 .BR -B ", " --bind " \fIn\fR[KM]"
 bind to a specific interface or multicast address
diff --git a/src/iperf_udp.c b/src/iperf_udp.c
index fea5024c7..f32a1bfd3 100644
--- a/src/iperf_udp.c
+++ b/src/iperf_udp.c
@@ -188,6 +188,22 @@ iperf_udp_accept(struct iperf_test *test)
         return -1;
     }
 
+    /*
+     * Set socket buffer size if requested.  Do this for both sending and
+     * receiving so that we can cover both normal and --reverse operation.
+     */
+    int opt;
+    if ((opt = test->settings->socket_bufsize)) {
+        if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, sizeof(opt)) < 0) {
+            i_errno = IESETBUF;
+            return -1;
+        }
+        if (setsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, sizeof(opt)) < 0) {
+            i_errno = IESETBUF;
+            return -1;
+        }
+    }
+
     /*
      * Create a new "listening" socket to replace the one we were using before.
      */
@@ -251,6 +267,22 @@ iperf_udp_connect(struct iperf_test *test)
         return -1;
     }
 
+    /*
+     * Set socket buffer size if requested.  Do this for both sending and
+     * receiving so that we can cover both normal and --reverse operation.
+     */
+    int opt;
+    if ((opt = test->settings->socket_bufsize)) {
+        if (setsockopt(s, SOL_SOCKET, SO_RCVBUF, &opt, sizeof(opt)) < 0) {
+            i_errno = IESETBUF;
+            return -1;
+        }
+        if (setsockopt(s, SOL_SOCKET, SO_SNDBUF, &opt, sizeof(opt)) < 0) {
+            i_errno = IESETBUF;
+            return -1;
+        }
+    }
+
     /*
      * Write a datagram to the UDP stream to let the server know we're here.
      * The server learns our address by obtaining its peer's address.
diff --git a/src/locale.c b/src/locale.c
index d238f8b2a..8b917fcfb 100644
--- a/src/locale.c
+++ b/src/locale.c
@@ -124,7 +124,7 @@ const char usage_longstr[] = "Usage: iperf [-s|-c host] [options]\n"
 			   "                            (default %d KB for TCP, %d KB for UDP)\n"
                            "  -P, --parallel  #         number of parallel client streams to run\n"
                            "  -R, --reverse             run in reverse mode (server sends, client receives)\n"
-                           "  -w, --window    #[KMG]    TCP window size (socket buffer size)\n"
+                           "  -w, --window    #[KMG]    set window size / socket buffer size\n"
 #if defined(linux)
                            "  -C, --linux-congestion <algo>  set TCP congestion control algorithm (Linux only)\n"
 #endif
